cancel_evt(string fac, string wc, int doit) 
{
    object obj_list,obj,atev_list,atev;
    int obj_list_len,atev_len, atev_stat, i,j;
    string common_name_attr, common_name, skip, obj_pid;

    if(fac=="cr") {
        common_name_attr="ref_num";
    }
    else if (fac=="chg") {
        common_name_attr="chg_ref_num";
    }
    else if (fac=="iss") {
        common_name_attr="ref_num";
    }
    else if (fac=="wf") {
        common_name_attr="persistent_id";
    }
    else {
        printf("Error: Unsopported factory!\n");
        return;
    }
    
    send_wait(0, top_object(),"call_attr",fac,"sync_fetch","STATIC",wc,-1,0);
    if(msg_error()) {
       printf("Error occured while trying to get data:%s\n",msg[0]);
       return;
    }
    obj_list= msg[0];
    obj_list_len=msg[1];

    for(i=0;i<obj_list_len;i++) {
        set_ilimit(100000);
        send_wait(0, obj_list,"dob_by_index","DEFAULT",i,i);
        if(msg_error()) {
           printf("Error occured while trying to get data:%s\n",msg[0]);
           continue;
        }
        obj=msg[0];
        send_wait(0, obj,"call_attr", common_name_attr,"get_val");
        common_name=msg[0];

        send_wait(0, obj,"call_attr", "persistent_id","get_val");
        obj_pid=msg[0];
		
        // get atev's
		send_wait(0,top_object(),"call_attr","atev","sync_fetch","STATIC",format("obj_id='%s' and group_name='SLA'", obj_pid),-1,0);
        if(msg_error()) {
            printf("Error occured while trying to get event list:%s\n",msg[0]);
            continue;
        }
        atev_list=msg[0];
        atev_len=msg[1];
        


	    // send_wait(0, obj,"call_attr", att_evt_list_attr+".length","get_val");
        // evt_l=msg[0];
        //skip objects with no events

        if(atev_len>0) {
            printf("found '%s' '%s with %d events\n", fac, common_name, atev_len);
        }
        else {
            if (!is_empty(skip)) skip+=", ";
            skip+= common_name;
        }

        if(doit==1)
		   send_wait(0, top_object(), "call_attr", "atev", "nuke_by_id", (object)(NULL), obj_pid, (string)(NULL), 0);


        // loop through events
        for(j=0;j<atev_len;j++) {
           send_wait(0,atev_list,"dob_by_index","DEFAULT",j,j);
           atev=msg[0];
           printf("atev.id=%d group_name=%s Status=",atev.id, atev.group_name);
           atev_stat=atev.status_flag;
           if(atev_stat==0) printf("Cancelled\n");
           else if(atev_stat==1) printf("Fired\n");
           else if(atev_stat==2) printf("Waiting\n");
           else if(atev_stat==3) printf("Repeating\n");
           else if(atev_stat==4) printf("Hosed\n");
           else if(atev_stat==12) printf("Delayed Waiting\n");
           else if(atev_stat==13) printf("Delayed Repeating\n");
           else printf("Unknwown %d\n",atev_stat);
        }
    }
    printf("Skipped Objects :%s\n",skip);
}

